//+------------------------------------------------------------------+
//|                                                     DrawBars.mq4 |
//|                                                        Kasatik42 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Kasatik42"
#property link      ""
#property version   "1.00"
#property strict
#property indicator_chart_window

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 MediumPurple
#property indicator_color2 MediumPurple
//---- input parameters
extern int       Width=2;
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,Width);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,Width);
   SetIndexBuffer(1,ExtMapBuffer2);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   ObjectsDeleteAll(0, "c");
}
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int    limit=Bars;
   for(int i=0; i<limit; i++)
   {
      ExtMapBuffer1[i]=High[i];
      ExtMapBuffer2[i]=Low[i];
      DrawArrow(i);
   }
   
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
void DrawArrow(int i)
{
    ObjectDelete(0, "c" + TimeToStr(iTime(Symbol(), 0, i)));
    ObjectCreate(0, "c" + TimeToStr(iTime(Symbol(), 0, i)), OBJ_TREND, 0, Time[i], Close[i], Time[i]+PeriodSeconds(), Close[i]);
    ObjectSetInteger (0, "c" + TimeToStr(iTime(Symbol(), 0, i)), OBJPROP_RAY_RIGHT, false);
    ObjectSetInteger(0, "c" + TimeToStr(iTime(Symbol(), 0, i)), OBJPROP_COLOR, MediumPurple);
    ObjectSetInteger(0, "c" + TimeToStr(iTime(Symbol(), 0, i)), OBJPROP_WIDTH, Width);
}
//+------------------------------------------------------------------+